/// <reference types="react" />
import { DataType, ErrorMessages, Props, RegisterInput, OnSubmit } from './types';
export default function useForm<Data extends DataType>({ mode, validationSchema, defaultValues, validationFields, nativeValidation, submitFocusError, }?: Props<Data>): {
    register: (refOrValidateRule: any, validateRule?: RegisterInput | undefined) => ((ref: any) => void) | undefined;
    handleSubmit: (callback: OnSubmit<Data>) => (e: import("react").SyntheticEvent<Element, Event>) => Promise<void>;
    watch: (fieldNames?: string | string[] | undefined, defaultValue?: string | Partial<Data> | undefined) => any;
    unSubscribe: () => void;
    reset: () => void;
    clearError: <Name extends keyof Data>(name: Extract<Name, string>) => void;
    setError: <Name extends keyof Data>(name: Extract<Name, string>, type?: string | undefined, message?: string | undefined, ref?: any) => void;
    setValue: <Name extends keyof Data>(name: Extract<Name, string>, value: Data[Name], shouldValidate?: boolean) => void;
    triggerValidation: <Name extends keyof Data>(payload: {
        name: Extract<keyof Data, string>;
        value?: Data[Name] | undefined;
    } | {
        name: Extract<keyof Data, string>;
        value?: Data[Name] | undefined;
    }[]) => Promise<boolean>;
    getValues: () => Data;
    errors: ErrorMessages<Data>;
    formState: {
        isValid: boolean;
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: {}[];
        isSubmitting: boolean;
    };
};
